<template>
  <div>
    <div class="blanco">
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <v-row>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <div class="subtitle-2">
                  <strong>Título del documento</strong
                  ><span class="tRojo">*</span>
                </div>
                <v-text-field
                  v-model.trim="documento.titulo"
                  maxlength="100"
                  placeholder="Título ejemplo"
                  :error="$v.documento.titulo.$error"
                  counter
                >
                  <template v-if="$v.documento.titulo.$error" v-slot:append>
                    <v-popover placement="bottom-end" color="red" offset="16">
                      <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                      <template slot="popover">
                        <div
                          @click="$v.documento.titulo.$reset()"
                          v-close-popover
                        >
                          <div v-if="!$v.documento.titulo.required">
                            ¡No te olvides de éste campo!
                          </div>
                        </div>
                      </template>
                    </v-popover>
                  </template>
                </v-text-field>
              </v-col>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <div class="subtitle-2">
                  <strong>Objetivo del documento</strong>
                  <span class="tRojo">*</span>
                </div>
                <v-textarea
                  v-model.trim="documento.objetivo"
                  placeholder="Utiliza palabras clave y se breve"
                  no-resize
                  :error="$v.documento.objetivo.$error"
                  maxlength="500"
                  counter
                  rows="4"
                />
              </v-col>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <FolioEtiquetas
                  @loaded="validateSteps"
                  v-model="dataFolioEtiquetas"
                  :folio="folio"
                />
              </v-col>
              <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                <div class="subtitle-2">
                  <strong>Versión</strong> <span class="tRojo">*</span>
                </div>
                <v-text-field
                  v-model.trim="documento.version"
                  maxlength="50"
                  placeholder="Versión p.Ej. 1.1"
                  :error="$v.documento.version.$error"
                  counter
                >
                  <template v-if="$v.documento.version.$error" v-slot:append>
                    <v-popover placement="bottom-end" color="red" offset="16">
                      <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                      <template slot="popover">
                        <div
                          @click="$v.documento.version.$reset()"
                          v-close-popover
                        >
                          <div v-if="!$v.documento.version.required">
                            ¡No te olvides de éste campo!
                          </div>
                        </div>
                      </template>
                    </v-popover>
                  </template>
                </v-text-field>
              </v-col>
              <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
                <div class="subtitle-2">
                  <strong>Control de cambios</strong>
                  <span class="tRojo">*</span>
                </div>
                <v-text-field
                  v-model.trim="documento.controlCambios"
                  maxlength="50"
                  placeholder="p.Ej. Creación del documento"
                  :error="$v.documento.controlCambios.$error"
                  counter
                >
                  <template
                    v-if="$v.documento.controlCambios.$error"
                    v-slot:append
                  >
                    <v-popover placement="bottom-end" color="red" offset="16">
                      <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                      <template slot="popover">
                        <div
                          @click="$v.documento.controlCambios.$reset()"
                          v-close-popover
                        >
                          <div v-if="!$v.documento.controlCambios.required">
                            ¡No te olvides de éste campo!
                          </div>
                        </div>
                      </template>
                    </v-popover>
                  </template>
                </v-text-field>
              </v-col>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <div class="subtitle-2">
                  <strong>Vigente a partir de:</strong>
                  <span class="tRojo">*</span>
                </div>
                <v-menu
                  v-model="menuFecha"
                  :close-on-content-click="false"
                  transition="scale-transition"
                  offset-y
                  max-width="290px"
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="dateFormatted"
                      hint="DD-MM-YYYY"
                      persistent-hint
                      readonly
                      append-icon="mdi-calendar"
                      v-bind="attrs"
                      v-on="on"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    v-model="documento.fechaInicio"
                    no-title
                    @input="menuFecha = false"
                  ></v-date-picker>
                </v-menu>
              </v-col>
            </v-row>
          </v-col>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            <v-row>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <div class="subtitle-2">
                  <strong>Modelo de negocio</strong>
                  <span class="tRojo">*</span>
                </div>
                <FolioArchivosModelo
                  ref="archivo-modelo"
                  v-model="dataFolioArchivosModelo"
                  :type="1"
                  :folio="folio"
                  @loaded="validateSteps"
                />
              </v-col>
              <v-col :cols="12" :sm="12" :md="12" :lg="12" :xl="12">
                <div class="subtitle-2">
                  <strong>Elemento contextual </strong>(Opcional)
                  <span class="tRojo">*</span>
                </div>
                <FolioArchivoContextual
                  ref="archivo-contextual-modelo"
                  v-model="dataFolioArchivosContextualesModelo"
                  :type="2"
                  :folio="folio"
                  @loaded="validateSteps"
                />
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </div>
    </div>
  </div>
</template>
<script>
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import moment from "moment";
import FolioEtiquetas from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/documentos/componentes/FolioEtiquetas.vue";
import FolioArchivoContextual from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/documentos/componentes/Archivos.vue";
import FolioArchivosModelo from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/documentos/componentes/Archivos.vue";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Documento",
  components: {
    FolioEtiquetas,
    FolioArchivosModelo,
    FolioArchivoContextual,
  },
  props: ["folio"],
  data: (vm) => ({
    dataFolioEtiquetas: {
      value: [],
      validator: null,
    },
    idDocumento: null,
    posting: false,
    puting: false,
    documento: {
      titulo: null,
      objetivo: null,
      version: null,
      controlCambios: null,
      fechaInicio: new Date().toISOString().substr(0, 10),
    },
    dataFolioArchivosModelo: {
      value: [],
      validator: null,
    },
    dataFolioArchivosContextualesModelo: {
      value: [],
      validator: null,
    },
    dateFormatted: vm.formatDate(new Date().toISOString().substr(0, 10)),
    menuFecha: false,
  }),
  validations: {
    documento: {
      titulo: {
        required,
      },
      objetivo: {
        required,
      },
      version: {
        required,
      },
      controlCambios: {
        required,
      },
    },
    dataFolioEtiquetas: {
      value: {
        required,
      },
    },
    dataFolioArchivosModelo: {
      value: {
        required,
        $each: {
          idArchivo: {
            required,
          },
        },
      },
    },
    dataFolioArchivosContextualesModelo: {
      value: {
        required() {
          return true;
        },
      },
    },
  },
  watch: {
    documento: {
      handler: function(val, prev) {
        if (!this.$v.documento.$invalid) {
          if (this.idDocumento) {
            if (!this.puting) {
              this.putDocumento();
            }
          } else {
            if (!this.posting) {
              this.postDocumento();
            }
          }
        }
      },
      deep: true,
    },
    "documento.fechaInicio": function(val) {
      this.dateFormatted = this.formatDate(this.documento.fechaInicio);
    },
  },
  methods: {
    validateSteps() {
      this.$v.$touch();
      setTimeout(() => {
        this.$emit("loaded", true);
      }, 500);
    },
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    getDocumento() {
      var self = this;
      axios
        .get(
          "/modelo-negocio/folio-documentos/v1/" +
            this.folio.idFolio +
            "/documentos"
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            let documento = data.resultado.documentos[0];
            self.idDocumento = documento.idDocumento;
            delete documento.idFolio;
            delete documento.idDocumento;
            self.documento = documento;
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(() => {
          this.$emit("loaded", true);
        });
    },
    postDocumento() {
      const self = this;
      let body = this.documento;
      this.posting = true;
      axios
        .post(
          "/modelo-negocio/folio-documentos/v1/" +
            this.folio.idFolio +
            "/documentos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.idDocumento = data.resultado.id;
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(() => {
          self.posting = false;
        });
    },
    putDocumento() {
      const self = this;
      let body = this.documento;
      this.puting = true;
      axios
        .put(
          "/modelo-negocio/folio-documentos/v1/" +
            this.folio.idFolio +
            "/documentos/" +
            this.idDocumento,
          body
        )
        .then((response) => {})
        .catch((error) => {
          console.log(error);
        })
        .finally(() => {
          self.puting = false;
        });
    },
    isValidArchivosModelo() {
      let archivosModeloRef = this.$refs["archivo-modelo"];
      let invalid = true;
      for (let index in archivosModeloRef) {
        if (archivosModeloRef[index].$v.$invalid) {
          invalid = false;
          break;
        }
      }
      return invalid;
    },
  },
  created() {
    this.getDocumento();
    this.dataFolioEtiquetas.validator = this.$v.dataFolioEtiquetas.value;
    this.dataFolioArchivosModelo.validator = this.$v.dataFolioArchivosModelo.value;
    this.dataFolioArchivosContextualesModelo.validator = this.$v.dataFolioArchivosContextualesModelo.value;
  },
};
</script>
